//Extrude splines
//By Steven Pettit
//V 1.1 06 August 2014

@warnings
@name Extrude Spline v2

main
{
 
	var ftmp = pntsa = pntsb = pnts = poly = tmp = tcrv = q = nil;
	var cnt, i, j, pcnt, pid = 0;
   	
    selmode(USER);
    pcnt = pointcount();
	ftmp = polycount();
	fcnt = ftmp[1];
    if((pcnt == 0) && (fcnt == 0)) error("Need something selected here!");
	if(fcnt > 0){
		//Polygons, ie hopefully curves, are selected and need to have the end points selected
		//In order for the extender to work.
		if(fcnt == 0) error("Need some polygons selected here!");
		editbegin();
			poly = polygons;
			for(i=1;i<=fcnt;i++)
			{
				q = polygons[i];
				if (q.isCurve() ) pnts += q.points[polypointcount(q)];
			}
		editend();
		//Clear our selection, and select the endpoints.
		selpolygon(CLEAR,POLYID,poly);
		selpoint(CLEAR);
		selpoint(SET,POINTID,pnts);
		//pcnt needs to be reset, because the pcnt above returns the number of points selected,
		//which will be every point in a selected polygon... which causes problems.  Nasty ones.
		pcnt = pointcount();
	}
 	
	undogroupbegin();
	cmdseq("Sel Points");
	editbegin();
		pntsa = points;
	editend(ABORT);
	copy();
	selpoint(CLEAR);
	paste();
	selpoint(SET, NPEQ, 0);
	editbegin();
		pntsb = points;
	editend(ABORT);
	
	editbegin();
		// New method, using copy() and polypoints() instead of destructively rebuilding each curves
		for(i=1; i<=pcnt; i++){
			tmp = pntsa[i].polygon();
			pid = tmp[1];
			cnt = pid.pointCount;
			var tcrv[cnt + 1];
			for(j=1; j<=cnt; j++){
				tcrv[j] = pid.points[j];
			}
			tcrv[cnt + 1] = pntsb[i];
			polypoints(pid, tcrv);
		}
    editend();
	undogroupend();
}

