@warnings
@name Flatten Points v2

main{
	var pcnt = 0;
	var bb = @<0,0,0>,<0,0,0>@;
	var cp = <0,0,0>;
	var tp = 0;
	var tr = cp;
	var N = cp;
	var D = 0;
	var vA = cp;
	var vB = cp;
	var tD = 0;
	//User Interface Stuff!
	var Axis = 1;
    var Method = 1;
		
	//debug();
	selmode(USER);
	pcnt = pointcount();
	if (pcnt == 0) error("Need to select some points!");
	//Get the bounding box
	bb = boundingbox();
	//Get the Center Point, down and dirty.
	cp = center(bb);
	
	//User Interface
    reqbegin("Flatten Points");
    reqsize(266,128);

    c1 = ctlchoice("Axis",Axis,@"X","Y","Z","Plane"@);
    ctlposition(c1,39,18);

    c2 = ctlchoice("Method",Method,@"Min","Max","Average"@);
    ctlposition(c2,38,44);

    return if !reqpost();

    Axis = getvalue(c1);
    Method = getvalue(c2);
	
	//If the Axis is PLANE, Method doesn't matter.
	if(Axis == 4) Method = 0;

    reqend();
	
	undogroupbegin();
	editbegin();
		if(Axis == 4){
			//Let's make a surface normal for a plane!
			//Determine an offset for the second point
			ofs = 2;
			if(pcnt > 8) ofs = ceil(pcnt *.25);
			//Equation of a plane(vector) is (N dot P) + D = 0
			//N = A cross B
			vA = normalize(pointinfo(points[1]) - cp);
			vB = normalize(pointinfo(points[ofs]) - cp);
			N = normalize(cross3d(vA,vB));
			//And solve for D for the centerpoint
			// D = - (N dot P)
			D = -(dot3d(N,cp));
		}
		foreach(p, points){
			tp = pointinfo(p);
			tr = <0,0,0>;
			switch(Method){
				case 1:
					//Minimum Value
					tr = bb[1];
					break;
				case 2:
					//Maximum Value
					tr = bb[2];
					break;
				case 3:
					//Average Value
					tr = cp;
					break;
				default:
					//We're here because Axis == 4 sets Method = 0;
					break;
			}
			switch(Axis){
				case 1:
					//Move to X
					tp = (<1,0,0> * tr) + (<0,1,1> * tp);
					break;
				case 2:
					//Move to Y	
					tp = (<0,1,0> * tr) + (<1,0,1> * tp);
					break;
				case 3:
					//Move to Z
					tp = (<0,0,1> * tr) + (<1,1,0> * tp);
					break;
				case 4:
					//Move to plane
					tD = (dot3d(N, tp)) + D;
					tp += N * -tD;
					break;
				default:
					break;
			}
			//Move the point, loop to the next
			pointmove(p,tp);
		}
	editend();
	undogroupend();
}