@warnings
@name Smooth Spline

main{
	iterations = 1;
		
	selmode(USER);
	ftmp = polycount();
	fcnt = ftmp[1];
	if(fcnt == 0) error("Need something selected here!");
	
	wrklist = nil;
	
	//A much cleaner way to get the curves in your selection...
	selhide(UNSELECTED);
	selpolygon(CLEAR);
	selpolygon(SET,CURVE);
	
	editbegin();
		wrklist = polygons;
	editend(ABORT);
	
	selpolygon(CLEAR);
	selunhide();
	
	if(!wrklist.count()) error("Need some splines selected...");

	reqbegin("Smooth Spline   Ver 2.0");
		c1 = ctlinteger("Iterations",iterations);
		return if !reqpost();
		iterations = getvalue(c1);
	reqend();
	
	debug();
	
	undogroupbegin();
		editbegin();
			foreach(c,wrklist){
				ti = iterations;
				c_cnt = polypointcount(c);
				
				var c_info[c_cnt+1];
				var c_pnts[c_cnt];
				
				c_info = polyinfo(c);
				
				//starting at index=2, get point values
				for(i=1; i<=c_cnt;i++)c_pnts[i] = pointinfo(c_info[i+1]);
				//Apply a simple smoothing function to points
				while(ti > 0){
					for(j=1; j<=c_cnt;j++){
						s_pnt = <0,0,0>;
						idx1 = max(j - 2,1);
						idx2 = max(j - 1,1);
						idx3 = j;
						idx4 = min(j + 1,c_cnt);
						idx5 = min(j + 2,c_cnt);
						if((j==c_cnt) || (j==1)){
							s_pnt = c_pnts[idx3];
						} else {
							s_pnt += c_pnts[idx1] + c_pnts[idx5];
							s_pnt += (4 * c_pnts[idx2]) + (4 * c_pnts[idx4]);
							s_pnt += 8 * c_pnts[idx3];
							s_pnt /= 18;
						}
						c_pnts[j] = s_pnt;
					}
					ti--;
				}
				for(j=1; j <= c_cnt; j++) pointmove(c_info[j+1],c_pnts[j]);
			}
		editend();
	undogroupend();
}