@warnings
@name Straighten Spline

main{
	//debug();
	selmode(USER);
	
	f = td1 = td2 = hp = t = i = 0;
	A = B = C = tn = ofs = <0,0,0>;
	
	//Ok, let's cycle through all the polys, making sure they are curves
	//Then straighten them out into a plane defined by the first point,
	//mid point, and end point.  We'll also need to throw out any curves
	//with less then 3 points.
	
	editbegin();
		foreach(f,polygons)
		{
			if(f.isCurve())
			{
				t = f.pointCount;
				if(t > 2)
				{
					hp = floor(((t - 1) / 2) + 1);
					//Equation of a plane : Point DOT Normal + D = 0
					//A, B, and C are three points on the curve
					//Normal = (A-B) X (A-C)
					//D = -1 * A DOT Normal
					A = pointinfo(f.points[1]);
					B = pointinfo(f.points[hp]);
					C = pointinfo(f.points[t]);
					tn = normalize(cross3d( (A - B), (A - C)));
					td1 = -dot3d(A,tn);
					//Ok, we've got our plane.  facing isn't important, because
					//curves don't have a front or back.
					for(i = 2; i <=t; i++)
					{
						//Let's move our point to where it needs to be...
						if ((i != 1) || (i != hp) || (i != t))
						{
							//pts A,B and C should all be on the plane, so
							//there is no need to move them.  i == 1 should
							//never occur, but we'll trap it anyway...
							q = pointinfo(f.points[i]);
							td2 = - dot3d(q,tn);
							ofs = q - ((td1-td2) * tn);
							pointmove(f.points[i], ofs);					
						}
						
					}
				}
			}
		}
	editend();
}